#
# Copyright 2018 CERN/Switzerland
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

apiVersion: apps/v1beta1
kind: Deployment
metadata:
  name: spark-history-server
  namespace: sparkoperator
  labels:
    app.kubernetes.io/name: spark-history-server
    app.kubernetes.io/version: v2.4.0
spec:
  replicas: 1
  selector:
    matchLabels:
      app.kubernetes.io/name: spark-history-server
      app.kubernetes.io/version: v2.4.0
  template:
    metadata:
      labels:
        app.kubernetes.io/name: spark-history-server
        app.kubernetes.io/version: v2.4.0
    spec:
      volumes:
      - name: spark-default-config
        configMap:
          name: spark-default-config
      containers:
        - name: spark-history-server
          image: gitlab-registry.cern.ch/db/spark-service/docker-registry/spark:v2.4.0-hadoop3.1
          imagePullPolicy: Always
          command: ["/bin/sh", "-c", "/opt/spark/sbin/start-history-server.sh"]
          ports:
            - containerPort: 18080
              protocol: TCP
          volumeMounts:
            - name: spark-default-config
              mountPath: /opt/spark/conf
          env:
            - name: SPARK_NO_DAEMONIZE
              value: "true"
            - name: SPARK_CONF_DIR
              value: /opt/spark/conf
---
apiVersion: v1
kind: Service
metadata:
  name: spark-history-service
  namespace: sparkoperator
  labels:
    app.kubernetes.io/name: spark-history-service
    app.kubernetes.io/version: v2.4.0
spec:
  type: NodePort
  selector:
    app.kubernetes.io/name: spark-history-server
  ports:
    - port: 80
      targetPort: 18080
      protocol: TCP